/**
 * @file FootyDoc.cpp
 * @brief hLgǗNX̎
 * @author ShinjiWatanabe
 * @version 1.0
 */

#include "FootyDoc.h"

//-----------------------------------------------------------------------------
/**
 * @brief RXgN^łB
 */
CFootyDoc::CFootyDoc()	:
	m_nTabLen( 4 ),
	m_nLapelMode( 0 ),
	m_nLapelColumns( 1024 ),
	m_nSelectType( SELECT_NONE ),
	m_nLineMode( LM_CRLF ),
	m_bReadOnly( false ),
	m_bInsertMode( true ),
	m_pFuncMoveCaret( NULL ),
	m_pDataMoveCaret( NULL ),
	m_pFuncTextModified( NULL ),
	m_pDataTextModified( NULL ),
	m_pFuncInsertMode( NULL ),
	m_pDataInsertModeChanged( NULL )
{
	f_SpeedDraw = 0;
}

//-----------------------------------------------------------------------------
/**
 * @brief fXgN^łB
 */
CFootyDoc::~CFootyDoc()
{
}

//-----------------------------------------------------------------------------
/**
 * @brief ̐VK쐬
 */
void CFootyDoc::CreateNew(int nGlobalID)
{
	// ܂ł̏SĔj
	m_lsLines.clear();
	m_lsUndoBuffer.clear();
	m_lsEmphasisWord.clear();
	m_pNowUndoPos = m_lsUndoBuffer.end();
	SetSavePoint();
	SetReadOnly( false );
	
	// ŏ̂Ps}
	CFootyLine cFirstLine;
	cFirstLine.m_strLineData = L"";
	m_lsLines.push_back(cFirstLine);
	
	// GfB^̈ʒuݒ肷
	m_cCaretPos.SetPosition(&m_lsLines,0,0);
	SendMoveCaretCallBack();
	for (int i=0;i<4;i++)
	{
		m_cFirstVisibleLine[i].SetPosition(m_lsLines.begin());
	}
	
	// ϐ
	m_nSelectType = SELECT_NONE;
	m_nLineMode = LM_CRLF;
	m_nGlobalID = nGlobalID;
}

//-----------------------------------------------------------------------------
/**
 * @brief ҏWĂ邩ǂ̃Z[u|CgƂēo^鏈
 */
void CFootyDoc::SetSavePoint()
{
	m_pSavedPos = m_pNowUndoPos;
	m_bCannotReachSavedPos = false;
}

//-----------------------------------------------------------------------------
/**
 * @brief ҏWĂ邩擾鏈
 */
bool CFootyDoc::IsEdited()
{
	if (m_bCannotReachSavedPos)		// Z[u|Cgɂǂ蒅ȂƂ
		return true;				// ҏWĂ
	else							// ǂƂ
		return m_pNowUndoPos != m_pSavedPos;
}

//-----------------------------------------------------------------------------
/**
 * @brief 蒼񐔂擾鏈
 */
int CFootyDoc::GetRedoRem()
{
	std::list<CUndoBuffer>::iterator p = m_pNowUndoPos;
	int nRedoNum;
	for(nRedoNum = 0; p != m_lsUndoBuffer.end() ; p++, nRedoNum++);
	return nRedoNum;
}

//-----------------------------------------------------------------------------
/**
 * @brief ɖ߂񐔂擾鏈
 */
int CFootyDoc::GetUndoRem()
{
	std::list<CUndoBuffer>::iterator p = m_pNowUndoPos;
	int nUndoNum = 0;
	if( p != m_lsUndoBuffer.end() || !m_lsUndoBuffer.empty() ) {
		for(; p != m_lsUndoBuffer.begin() ; p--, nUndoNum++);
	}
	return nUndoNum;
}

//-----------------------------------------------------------------------------
/**
 * @brief SẴeLXgZbg܂
 */
void CFootyDoc::SetText( const wchar_t *pString )
{
	// f[^Zbg
	CreateNew(m_nGlobalID);
	InsertString( pString, false, false, true );
	
	// ϐ̏
	m_cCaretPos.SetPosition(&m_lsLines,0,0);
	SendMoveCaretCallBack();
}

//-----------------------------------------------------------------------------
/**
 * @brief w肳ꂽsԍ̍sNXւ̃Ce[^擾܂(0x[X)B
 */
LinePt CFootyDoc::GetLine(size_t nLine)
{
	// 錾
	size_t i;				// ԍp
	LinePt iterNowLine;		// Ɨp̃Ce[^
	// G[`FbN
	if (GetLineNum() <= nLine)return m_lsLines.end();
	// Jn
	iterNowLine=m_lsLines.begin();
	for (i=0;i<nLine;i++)iterNowLine++;
	// lԋp
	return iterNowLine;
}

//-----------------------------------------------------------------------------
/**
 * @brief {̍ŏIs擾郋[`łB
 */
LinePt CFootyDoc::GetLastLine()
{
	LinePt pLast = m_lsLines.end();
	pLast -- ;
	return pLast;
}

//-----------------------------------------------------------------------------
/**
 * @brief \ݒ肵܂B
 */
bool CFootyDoc::AddEmphasis(const wchar_t *pString1,const wchar_t *pString2,
	int nType,int nFlags,int nLevel,int nOnLevel,int nIndependence,COLORREF nColor)
{
	/*G[`FbN*/
	if (!pString1)return false;
	if (nLevel < 1 || sizeof(int)*8 - 1 < nLevel)return false;
	/*ݒ肷*/
	CEmphasisWord cEmpWord;
	cEmpWord.SetValues(pString1,pString2,
		nType,nFlags,nLevel,nOnLevel,nIndependence,nColor);
	/*ReiɊi[*/
	m_lsEmphasisWord.push_back(cEmpWord);
	return true;
}

//-----------------------------------------------------------------------------
/**
 * @brief \m肵܂B
 */
void CFootyDoc::FlushEmphasis()
{
	for (LinePt pLine = m_lsLines.begin();pLine != m_lsLines.end();pLine++)
	{
		pLine->SetEmphasisChached(false);
	}
}

//-----------------------------------------------------------------------------
/**
 * @brief \o^Ă̂Sč폜
 */
void CFootyDoc::ClearEmphasis()
{
	m_lsEmphasisWord.clear();
}

//-----------------------------------------------------------------------------
/** * @brief }Ԃω鏈ł

 */
void CFootyDoc::SetInsertMode(bool bInsertMode)
{
	m_bInsertMode = bInsertMode;
	if (m_pFuncInsertMode)
	{
		m_pFuncInsertMode(m_nGlobalID,m_pDataInsertModeChanged,bInsertMode);
	}
}

//-----------------------------------------------------------------------------
/**
 * @brief TAB̕ݒ肵܂
 */
void CFootyDoc::SetTabLen(size_t nTabLen){
	if (0 < nTabLen){
		m_nTabLen = nTabLen;
	}
}

//-----------------------------------------------------------------------------
/**
 * CFootyDoc::InsertString
 * @brief ݂̃Lbgʒuɕ}܂B
 * @param pString }镶(NULLI[)
 * @param bRecUndo truêƂAhDL^
 * @param bOverwritable INSERTL[ɂ㏑`FbNLɂ
 * @param bMemLineMode sR[h͂̃̕R[hƂĕۑ
 */
CFootyDoc::RedrawType CFootyDoc::InsertString
		(const wchar_t *pString,bool bRecUndo,bool bOverwritable,bool bMemLineMode)
{
	// 錾
	const wchar_t *pWork;			//!< sʒup
	std::wstring strRestLine;		//!< }ʒuȍ~̃f[^
	LinePt pLine,pBeginLine;
	size_t nNumLines = 0;
	size_t nPos;
	CUndoBuffer cUndo;

	// G[`FbN
	if ( !pString )return REDRAW_FAILED;
	if ( IsReadOnly() ) return REDRAW_FAILED;
	
	// ㏑̏ꍇ
	if (bOverwritable && !m_bInsertMode && !IsSelecting())
	{
		// v
		size_t nStrLen = wcslen(pString);
		size_t nLineLeft = m_cCaretPos.GetLinePointer()->GetLineLength()
							- m_cCaretPos.GetPosition();
		// I
		SetSelectStart();
		m_cCaretPos.MoveColumnForward(&m_lsLines,min(nLineLeft,nStrLen));
		SetSelectEndNormal();
		// āAċA
		return InsertString(pString);
	}

	// Iʒu폜ăAhD
	if (bRecUndo)
	{
		if (IsSelecting())
		{
			DeleteSelected(&cUndo);
			cUndo.m_nUndoType = CUndoBuffer::UNDOTYPE_REPLACE;
		}
		else cUndo.m_nUndoType = CUndoBuffer::UNDOTYPE_INSERT;
		cUndo.m_cAfterStart = m_cCaretPos;
		cUndo.m_strAfter = pString;
	}
	else DeleteSelected(NULL);
	
	// Lbg̈ʒu擾
	pLine = m_cCaretPos.GetLinePointer();
	pBeginLine = pLine;
	nPos = m_cCaretPos.GetPosition();

	// 𑖍Ă
	for (pWork=pString;;pWork++)
	{
		if (*pWork == L'\r')
		{
			if (*(pWork+1) == L'\n')	// CRLF
			{
				ReturnLine(&pLine,&pString,pWork,
							nPos,&strRestLine,2,nNumLines==0);
				nNumLines++;
				pWork++;
				if (bMemLineMode)m_nLineMode = LM_CRLF;
			}
			else						// LbW^[̂
			{
				ReturnLine(&pLine,&pString,pWork,
							nPos,&strRestLine,1,nNumLines==0);
				nNumLines++;
				if (bMemLineMode)m_nLineMode = LM_CR;
			}
		}
		else if (*pWork == L'\n')		// CtB[h
		{
			ReturnLine(&pLine,&pString,pWork,
						nPos,&strRestLine,1,nNumLines==0);
			nNumLines++;
			if (bMemLineMode)m_nLineMode = LM_LF;
		}
		else if (*pWork == L'\0')		// I[
		{
			if (!nNumLines)				// ܂łɉsƂ
			{
				// ̈ʒuɑSĂ̕}
				pLine->m_strLineData.insert(nPos,pString);
				SetLineInfo(pBeginLine);
				// Lbgʒuړ
				m_cCaretPos.MoveColumnForward(&m_lsLines,(size_t)(pWork-pString));
			}
			else						// sƂ
			{
				// obNAbv
				pLine->m_strLineData = pString + strRestLine;
				// ύXm肷
				SetLineInfo(pBeginLine,pLine);
				// Lbgʒuړ
				m_cCaretPos.MoveRealNext(&m_lsLines,nNumLines);
				m_cCaretPos.MoveColumnForward(&m_lsLines,(size_t)(pWork-pString));
			}
			// AhD}
			if (bRecUndo)
			{
				cUndo.m_cAfterEnd = m_cCaretPos;
				PushBackUndo(&cUndo);
			}
			break;
		}
	}
	SendMoveCaretCallBack();
	return REDRAW_ALL;
}

//-----------------------------------------------------------------------------
/**
 * CFootyDoc::ReturnLine
 * @brief InsertString̃Tu[`ŁAss܂B
 */
void CFootyDoc::ReturnLine(LinePt *pNowLine,const wchar_t **pString,const wchar_t *pWork,
						   size_t nPos,std::wstring *pRestStr,int n,bool bFirst)
{
	// 錾
	LinePt pLine = *pNowLine;
	CFootyLine cInsertLine;
	
	// f[^}
	if (!bFirst)	// ŏłȂƂ̓Rs[
		pLine->m_strLineData = std::wstring(*pString,(size_t)(pWork - *pString));
	else			// ŏ̈ʒu̎̓obNAbv
	{
		if (nPos == pLine->GetLineLength())
		{
			*pRestStr = L"";
		}
		else
		{
			*pRestStr = pLine->m_strLineData.substr(nPos);
			pLine->m_strLineData.erase(nPos,pLine->GetLineLength()-nPos);
		}
		pLine->m_strLineData += std::wstring(*pString,(size_t)(pWork - *pString));
	}
	//̍s𐶐
	pLine++;
	m_lsLines.insert(pLine,cInsertLine);
	// |C^
	*pString = pWork + n;
	(*pNowLine)++;
}

//-----------------------------------------------------------------------------
/**
 * CFootyDoc::InsertChar
 * @brief Ch}܂
 * @param wChar }镶
 * @return `͈
 */
CFootyDoc::RedrawType CFootyDoc::InsertChar(wchar_t wChar)
{
	// 錾
	LinePt pLine;
	size_t nPos;
	CUndoBuffer cUndo;
	CEditPosition cEditPosition = m_cCaretPos;
	RedrawType nRetRedraw = REDRAW_LINE;
	
	if ( IsReadOnly() ) return REDRAW_FAILED;
	
	// I𕶎폜AAhDi[
	if ( IsSelecting() )
	{
		DeleteSelected(&cUndo);
		cUndo.m_nUndoType = CUndoBuffer::UNDOTYPE_REPLACE;
		nRetRedraw = REDRAW_ALL;
	}
	else if (m_bInsertMode || m_cCaretPos.GetPosition() == m_cCaretPos.GetLinePointer()->GetLineLength())
	{
		cUndo.m_nUndoType = CUndoBuffer::UNDOTYPE_INSERT;
	}
	else
	{
		// ㏑Ƃ́AAhDKv
		cUndo.m_cBeforeStart = cEditPosition;
		cEditPosition.MoveColumnForward(&m_lsLines,1);
		cUndo.m_cBeforeEnd = cEditPosition;
		cUndo.m_strBefore += m_cCaretPos.GetLinePointer()->GetLineData()
			[m_cCaretPos.GetPosition()];
		cUndo.m_nUndoType = CUndoBuffer::UNDOTYPE_REPLACE;
	}
	cUndo.m_strAfter += wChar;
	
	// 
	pLine = m_cCaretPos.GetLinePointer();
	nPos = m_cCaretPos.GetPosition();
	if (m_bInsertMode || nPos == pLine->GetLineLength())
		pLine->m_strLineData.insert(nPos,1,wChar);
	else
		pLine->m_strLineData[nPos] = wChar;
	
	// ϗssɂȂ邩`FbN
	size_t nBeforeEthic = pLine->GetEthicLine();
	if (SetLineInfo(pLine))
		nRetRedraw = REDRAW_ALL;
	if (nBeforeEthic != pLine->GetEthicLine())
		nRetRedraw = REDRAW_ALL;

	// 𑝉
	cUndo.m_cAfterStart = m_cCaretPos;
	m_cCaretPos.MoveColumnForward(&m_lsLines,1);
	cUndo.m_cAfterEnd = m_cCaretPos;

	// AhD}
	PushBackUndo(&cUndo);
	SendMoveCaretCallBack();
	return nRetRedraw;
}

//-----------------------------------------------------------------------------
/**
 * @brief ݂̃Lbgʒuŉss܂B
 * @param	bIndentMode [in] I[gCfgsǂ
 */
CFootyDoc::RedrawType CFootyDoc::InsertReturn( bool bIndentMode )
{
	// 錾
	CUndoBuffer cUndo;
	CFootyLine cNewLine;
	LinePt pLine, pInsertPos;
	size_t nPos;
	
	if ( IsReadOnly() ) return REDRAW_FAILED;
	
	// Iʒu폜܂
	if (IsSelecting())
	{
		DeleteSelected(&cUndo);
		cUndo.m_nUndoType = CUndoBuffer::UNDOTYPE_REPLACE;
	}
	else
	{
		cUndo.m_nUndoType = CUndoBuffer::UNDOTYPE_INSERT;
	}
	cUndo.m_cAfterStart = m_cCaretPos;
	
	// s}ʒu擾܂
	pLine = m_cCaretPos.GetLinePointer();
	nPos = m_cCaretPos.GetPosition();

	// I[gCfgƂđ}ł镶JEg܂
	size_t nIndentChars = 0;
	if ( bIndentMode )
	{
		nIndentChars = pLine->CalcAutoIndentPos( nPos );
	}

	// }AƂȂeLXg쐬܂
	cUndo.m_strAfter = L"\r\n";
	if  ( nIndentChars != 0 )
	{
		cUndo.m_strAfter.append( pLine->GetLineData(), nIndentChars );
	}

	// sŉsĂȂƂ͎̍sɉ񂵂܂
	if (pLine->GetLineLength() != nPos)
	{
		if ( nIndentChars == 0 )
		{
			cNewLine.m_strLineData = &pLine->GetLineData()[nPos];
		}
		else
		{
			cNewLine.m_strLineData.append( pLine->GetLineData(), nIndentChars );
			cNewLine.m_strLineData += &pLine->GetLineData()[nPos];
		}
		pLine->m_strLineData.erase(nPos);
	}
	else if  ( nIndentChars != 0 )
	{
		cNewLine.m_strLineData.append( pLine->GetLineData(), nIndentChars );
	}

	// ̍sXgɒǉ
	pInsertPos = pLine;
	pInsertPos++;
	pInsertPos = m_lsLines.insert( pInsertPos, cNewLine );
	SetLineInfo( pLine, pInsertPos );

	// Lbgʒuړ
	m_cCaretPos.SetPosition( pInsertPos, nIndentChars );

	// AhD[i[
	cUndo.m_cAfterEnd = m_cCaretPos;
	PushBackUndo(&cUndo);
	SendMoveCaretCallBack();
	return REDRAW_ALL;
}

//-----------------------------------------------------------------------------
/**
 * @brief ݂̃Lbgʒüsɋs}܂B
 * @param	bIndentMode [in] I[gCfgsǂ
 */
CFootyDoc::RedrawType CFootyDoc::InsertReturnUp( bool bIndentMode )
{
	if ( IsReadOnly() ) return REDRAW_FAILED;
	
	// IԂ̉
	m_nSelectType = SELECT_NONE;
	
	// 󋵂ɂď𕪂
	if (m_cCaretPos.GetLineNum() == 0)
	{
		// ԏ̍s̎́Äʒu̐擪ŉsƂɂ
		m_cCaretPos.SetPosition(m_cCaretPos.GetLinePointer(),0);
		InsertReturn( bIndentMode );
		m_cCaretPos.SetPosition(m_lsLines.begin(),0);
	}
	else
	{
		// ȊO̎́ÄʒüŉsƂɂ
		LinePt pLine = m_cCaretPos.GetLinePointer();
		pLine--;
		m_cCaretPos.SetPosition(pLine,pLine->GetLineLength());
		InsertReturn( bIndentMode );
	}
	return REDRAW_ALL;
}

//-----------------------------------------------------------------------------
/**
 * @brief ݂̃Lbgʒüsɋs}܂B
 * @param bIndent [in] Cfgsǂ
 */
CFootyDoc::RedrawType CFootyDoc::InsertReturnDown( bool bIndent )
{
	if ( IsReadOnly() ) return REDRAW_FAILED;
	
	// IԂ̉
	m_nSelectType = SELECT_NONE;
	
	// ȊO̎́ÄʒüŉsƂɂ
	m_cCaretPos.SetPosition(m_cCaretPos.GetLinePointer(),
		m_cCaretPos.GetLinePointer()->GetLineLength());
	InsertReturn( bIndent );
	return REDRAW_ALL;
}

//-----------------------------------------------------------------------------
/**
 * CFootyDoc::OnBackSpace
 * @brief BackSpaceL[ꂽƂ̏s܂B
 * @return ǂ̂悤ɍĕ`悷̂
 * @note K؂ȈʒuփLbgړ܂B
 */
CFootyDoc::RedrawType CFootyDoc::OnBackSpace()
{
	// 錾
	LinePt pLine = m_cCaretPos.GetLinePointer();
	size_t nPos = m_cCaretPos.GetPosition();
	CUndoBuffer cUndo;
	RedrawType nType;
	
	if ( IsReadOnly() ) return REDRAW_FAILED;
	
	// ꍇ
	if (IsSelecting())
	{
		nType = DeleteSelected(&cUndo);
		PushBackUndo(&cUndo);
		return nType;
	}
	else	// IĂȂƂ
	{
		if (nPos != 0)			// 폜
		{
			bool bIsSurrogatePair = CFootyLine::IsSurrogateTail(pLine->GetLineData()[nPos-1]);
			RedrawType nNeedRedraw = REDRAW_LINE;
			
			// AhD
			cUndo.m_nUndoType = CUndoBuffer::UNDOTYPE_DELETE;
			if (bIsSurrogatePair)
				cUndo.m_strBefore = pLine->m_strLineData.substr(nPos-2,2);
			else	
				cUndo.m_strBefore = pLine->m_strLineData.substr(nPos-1,1);
			cUndo.m_cBeforeEnd = m_cCaretPos;
			
			// 폜
			if (bIsSurrogatePair)
				pLine->m_strLineData.erase(nPos-2,2);
			else
				pLine->m_strLineData.erase(nPos-1,1);
			size_t nBeforeEthic = pLine->GetEthicLine();
			if (SetLineInfo(pLine))
				nNeedRedraw = REDRAW_ALL;
			if (nBeforeEthic != pLine->GetEthicLine())
				nNeedRedraw = REDRAW_ALL;
			
			// |WVړ
			if (bIsSurrogatePair)
				m_cCaretPos.MoveColumnBackward(&m_lsLines,2);
			else
				m_cCaretPos.MoveColumnBackward(&m_lsLines,1);
			
			// AhDi[
			cUndo.m_cBeforeStart = m_cCaretPos;
			PushBackUndo(&cUndo);
			SendMoveCaretCallBack();
			return nNeedRedraw;
		}
		else					// s폜
		{
			if (pLine != m_lsLines.begin())
			{
				// ̍s|C^擾
				LinePt pPrevLine = pLine;
				pPrevLine--;

				// AhDLbgʒuړ
				cUndo.m_nUndoType = CUndoBuffer::UNDOTYPE_DELETE;
				cUndo.m_strBefore = L"\r\n";
				cUndo.m_cBeforeEnd = m_cCaretPos;
				m_cCaretPos.MoveColumnBackward(&m_lsLines,1);
				cUndo.m_cBeforeStart = m_cCaretPos;
				PushBackUndo(&cUndo);

				// š
				pPrevLine->m_strLineData += pLine->GetLineData();

				// ݂̈ʒu폜
				DeleteLine(pLine);

				// XV
				LinePt pNextLine = pPrevLine;
				pNextLine++;      
				SetLineInfo(pPrevLine,pNextLine);  

				SendMoveCaretCallBack();
				return REDRAW_ALL;
			}
			else return REDRAW_NONE;
		}
	}
}

//-----------------------------------------------------------------------------
/**
 * CFootyDoc::OnDelete
 * @brief DeleteL[ꂽƂ̏s܂B
 * @return ǂ̂悤ɍĕ`悷̂
 */
CFootyDoc::RedrawType CFootyDoc::OnDelete()
{
	// 錾
	CUndoBuffer cUndo;
	RedrawType nType;
	
	if ( IsReadOnly() ) return REDRAW_FAILED;
	
	// IĂ邩ǂŏꍇ
	if (IsSelecting()){
		nType = DeleteSelected(&cUndo);
		PushBackUndo(&cUndo);
		return nType;
	}
	else{
		// OɈړĂBackSpaceƂ`ɂ
		CEditPosition cBackUp = m_cCaretPos;
		m_cCaretPos.MoveColumnForward(&m_lsLines,1);
		if (cBackUp != m_cCaretPos)	// Ⴄ
			return OnBackSpace();
		else						// 
			return REDRAW_NONE;
	}
}

//-----------------------------------------------------------------------------
/**
 * @brief w肵sȍ~̃ItZbglƎۂ̍sԍݒ肷郋[`
 * @param pBegin ݒ肷邽߂̊Jnʒu
 * @return SĂ̍ĕ`vƂtrue
 * @note pBegin͕񂪕ύXĂ̂URLƃ[AhXČB
 *       ȍ~̍s͋\SČ܂B
 */
bool CFootyDoc::SetLineInfo(LinePt pBegin)
{
	bool bAllRedraw = false;
	bool bPrevLineInfoChanged = false;
	bool bEmphasisChanged = false;
	
	// ŏ̍sm肳
	bPrevLineInfoChanged = pBegin->FlushString(m_nTabLen,m_nLapelColumns,m_nLapelMode);
	if (pBegin == m_lsLines.begin())
		bEmphasisChanged = pBegin->SearchEmphasis(NULL,&m_lsEmphasisWord);
	else
	{
		LinePt pPrevLine = pBegin;
		pPrevLine--;
		bEmphasisChanged = pBegin->SearchEmphasis(pPrevLine->GetBetweenNext(),&m_lsEmphasisWord);
	}
	bAllRedraw = bEmphasisChanged || bPrevLineInfoChanged;

	// [vĎW(pBegin̎̍sŌ܂Ń[v)
	pBegin++;
	for (LinePt pLine = pBegin; pLine != m_lsLines.end(); pLine++)
	{
		// ȌĂ
		if (bPrevLineInfoChanged && pLine != m_lsLines.begin())
		{
			LinePt pPrevLine = pLine;
			pPrevLine--;
			bPrevLineInfoChanged = pLine->SetPrevLineInfo(pPrevLine);
			bAllRedraw = bAllRedraw || bPrevLineInfoChanged;
		}

		// ςƂ͑SătO낵Ă
		if (bEmphasisChanged)
			pLine->SetEmphasisChached(false);
	}

	return bAllRedraw;
}

//-----------------------------------------------------------------------------
/**
 * @brief s̓eύXꂽƂȀWĂłB
 * @param pBegin ύẌŏ̍s
 * @param pEnd ύẌ̍Ō̍s
 * @return SĂ̍ĕ`vƂtrue
 */
bool CFootyDoc::SetLineInfo(LinePt pBegin, LinePt pEnd)
{
	LinePt pLine;
	bool bAllRedraw = false;
	bool bPrevLineInfoChanged = false;
	bool bEmphasisChanged = false;

	// ύXꂽ̈͏ɌĂ
	for (pLine = pBegin; ;pLine++)
	{
		// ꂪłɕ̍Ō̍ŝƂ͊֐I
		if (pLine == m_lsLines.end())return bAllRedraw;

		// ݂̍s𒲍
		bPrevLineInfoChanged = pLine->FlushString(m_nTabLen,m_nLapelColumns,m_nLapelMode);

		if (pLine == m_lsLines.begin())
			bEmphasisChanged = pLine->SearchEmphasis(NULL,&m_lsEmphasisWord);
		else
		{
			LinePt pPrevLine = pLine;
			pPrevLine--;
			bEmphasisChanged = pLine->SearchEmphasis(pPrevLine->GetBetweenNext(),&m_lsEmphasisWord);
			bPrevLineInfoChanged = pLine->SetPrevLineInfo(pPrevLine);
		}
		bAllRedraw = bAllRedraw || bEmphasisChanged || bPrevLineInfoChanged;

		// Ɍ̈𔲂邩ǂ̔
		if (pLine == pEnd)break;
	}

	// [včŌ܂ŎĂ
	for (pLine++ ; pLine != m_lsLines.end(); pLine++)
	{
		// ȌĂ
		if (bPrevLineInfoChanged && pLine != m_lsLines.begin())
		{
			LinePt pPrevLine = pLine;
			pPrevLine--;
			bPrevLineInfoChanged = pLine->SetPrevLineInfo(pPrevLine);
			bAllRedraw = bAllRedraw || bPrevLineInfoChanged;
		}

		// ςƂ͑SătO낵Ă
		if (bEmphasisChanged)
			pLine->SetEmphasisChached(false);
	}

	return bAllRedraw;
}

//-----------------------------------------------------------------------------
/**
 * @brief \̃LbV쐬鏈
 * @param pLine LbVvZJnʒu
 */
void CFootyDoc::SetChacheCommand(LinePt pLine)
{
	// \ʒuXV
	//SYSTEMTIME st;
	if (pLine == m_lsLines.begin())
	{
		pLine->SearchEmphasis(NULL,&m_lsEmphasisWord);
//GetLocalTime(&st);
//FOOTY2_PRINTF( L"SearchEmphasisI %dN%d%d%d%d%db%dms\n", st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond, st.wMilliseconds);
	}
	else
	{
		// LbVĂs擾(ݍs炳̂ڂČE}CiX)
		LinePt pStartLine;
		for (pStartLine = pLine;pStartLine != m_lsLines.begin();pStartLine--)
		{
			if (pStartLine->EmphasisChached()){
//GetLocalTime(&st);
//FOOTY2_PRINTF( L"LbVĂs݂I %dN%d%d%d%d%db%dms\n", st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond, st.wMilliseconds);
				break;
			}
//GetLocalTime(&st);
//FOOTY2_PRINTF( L"LbVsiEI %ds : %dN%d%d%d%d%db%dms\n", pStartLine, st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond, st.wMilliseconds);
		}

		// sLbVĂȂƂ
		if (pStartLine == m_lsLines.begin() && !pStartLine->EmphasisChached())
		{
			pStartLine->SearchEmphasis(NULL,&m_lsEmphasisWord);
//GetLocalTime(&st);
//FOOTY2_PRINTF( L"sLbVĂȂ %dN%d%d%d%d%db%dms\n", st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond, st.wMilliseconds);
		}

		//FOOTY2_PRINTF( L"LbVJnsHHH %d\n",pStartLine->GetRealLineNum());
		
		/*
		LinePt pNowLine;
		LinePt pPrevLine;
		int i = 0;
		for (pNowLine = pLine, i = 0;pNowLine != m_lsLines.begin();pNowLine--,pPrevLine--,i++)
		{
			if (i == 30)break;
			pNowLine->SearchEmphasis(pPrevLine->GetBetweenNext(),&m_lsEmphasisWord);

		}

		*/
		// `悪Lȏꍇ by inovia
		if (f_SpeedDraw != 0){
			// LbVĂs擾(ݍs炳̂ڂČE}CiX)
			int i = 0;
			for (pStartLine = pLine;pStartLine != m_lsLines.begin();pStartLine--)
			{
				if (i == 30)break;
				if (pStartLine->EmphasisChached()){
					break;
				}
				i++;
			}
		}
		// Jns_܂ŃLbV
		LinePt pPrevLine = pStartLine;//pStartLine;
		LinePt pNowLine = pStartLine;//pStartLine;

		for (pNowLine++;;pNowLine++,pPrevLine++)
		{
	//		FOOTY2_PRINTF( L"LbVJgs ǉ %d\n",pNowLine->GetRealLineNum());
	//GetLocalTime(&st);
	//FOOTY2_PRINTF( L"LbVǉiEI %ds%ds%ds : %dN%d%d%d%d%db%dms\n", pPrevLine,pPrevLine,pLine, st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond, st.wMilliseconds);
			pNowLine->SearchEmphasis(pPrevLine->GetBetweenNext(),&m_lsEmphasisWord);
			if (pNowLine == pLine)break;
		}

		
	}
}

//-----------------------------------------------------------------------------
/**
 * @brief s폜鏈łB 
 * @param pLine 폜s
 */
void CFootyDoc::DeleteLine(LinePt pLine)
{
	if ( IsReadOnly() ) return;
	
	for (int i=0;i<4;i++)
	{
		if (m_cFirstVisibleLine[i].GetLineNum() == pLine->GetRealLineNum()){
			m_cFirstVisibleLine[i].MoveRealBack(1);
		}
	}
	m_lsLines.erase(pLine);
}

//-----------------------------------------------------------------------------
/**
 * @brief w肳ꂽԂ̍sCɍ폜鏈
 * @param pStart Jns(폜)
 * @param pEnd Is(͍폜Ȃ)
 */
void CFootyDoc::DeleteLine(LinePt pStart,LinePt pEnd)
{
	if ( IsReadOnly() ) return;
	
	// 폜f[^̍sԍ擾
	size_t nRealStart = pStart->GetRealLineNum();
	LinePt pDelEnd = pEnd;
	pDelEnd--;
	size_t nRealEnd = pDelEnd->GetRealLineNum();

	// ŏɕ\ĂsƔĂ璲Ă
	for (int i=0;i<4;i++)
	{
		if (nRealStart <= m_cFirstVisibleLine[i].GetLineNum() &&
			m_cFirstVisibleLine[i].GetLineNum() <= nRealEnd)
		{
			m_cFirstVisibleLine[i].SetPosition(pStart);
			m_cFirstVisibleLine[i].MoveRealBack(1);
		}
	}

	// ۂɍ폜鏈
	m_lsLines.erase(pStart,pEnd);
}

//-----------------------------------------------------------------------------
/**
 * @brief LbgʒuPꂷ΂đO
 */
void CFootyDoc::MoveWordForward()
{
	LinePt pLine = m_cCaretPos.GetLinePointer();
	size_t nPos = m_cCaretPos.GetPosition();
	
	if (m_cCaretPos.GetPosition() != pLine->GetLineLength())
	{
		CFootyLine::WordInfo wiWord = pLine->GetWordInfo(nPos,false);
		m_cCaretPos.MoveColumnForward(&m_lsLines,wiWord.m_nEndPos - nPos);
	}
	else m_cCaretPos.MoveColumnForward(&m_lsLines,1);
	SendMoveCaretCallBack();
}

//-----------------------------------------------------------------------------
/**
 * @brief LbgʒuPꂷ΂Č
 */
void CFootyDoc::MoveWordBack()
{
	LinePt pLine = m_cCaretPos.GetLinePointer();
	size_t nPos = m_cCaretPos.GetPosition();
	
	if (m_cCaretPos.GetPosition() != 0)
	{
		CFootyLine::WordInfo wiWord = pLine->GetWordInfo(nPos);
		m_cCaretPos.MoveColumnBackward(&m_lsLines,nPos - wiWord.m_nBeginPos);
	}
	else m_cCaretPos.MoveColumnBackward(&m_lsLines,1);
	SendMoveCaretCallBack();
}

//-----------------------------------------------------------------------------
/**
 * @brief ܂Ԃݒ
 * @param nColumn 
 * @param nMode ܂Ԃ[h
 */
void CFootyDoc::SetLapel(size_t nColumn,int nMode)
{
	// Ԃݒ肷
	m_nLapelColumns = nColumn;
	m_nLapelMode = nMode;

	// [vĎW
	LinePt pLine = m_lsLines.begin();
	LinePt pPrevLine = m_lsLines.begin();
	pLine->FlushString(m_nTabLen,m_nLapelColumns,m_nLapelMode);
	
	for (pLine++;pLine != m_lsLines.end();pLine++,pPrevLine++)
	{
		pLine->FlushString(m_nTabLen,m_nLapelColumns,m_nLapelMode);
		pLine->SetPrevLineInfo(pPrevLine);
	}	
}
//-----------------------------------------------------------------------------
/**
 * @brief ` by inovia
 * @param	flag [in] tO
 */
void CFootyDoc::SetSpeedDraw( int flag )
{
	f_SpeedDraw = flag;
}
/*[EOF]*/
