
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include <winnt.h>

// DllMaiñA^b`Af^b`
#define DLL_ATTACH    0
#define DLL_DETACH    1

#define SIZE_OF_NT_SIGNATURE       (sizeof(DWORD))
#define SIZE_OF_PARAMETER_BLOCK    4096
#define IMAGE_PARAMETER_MAGIC      0xCDC31337

#define RVATOVA(base, offset) ( \
	(LPVOID)((DWORD)(base) + (DWORD)(offset)))

// NTVOl`
#define NTSIGNATURE(ptr) (  \
	(LPVOID)((PBYTE)(ptr) + \
	((PIMAGE_DOS_HEADER)(ptr))->e_lfanew))

// PEwb_ItZbg
#define PEFHDROFFSET(ptr) ( \
	(LPVOID)((PBYTE)(ptr) + \
	((PIMAGE_DOS_HEADER)(ptr))->e_lfanew + \
	SIZE_OF_NT_SIGNATURE))

// IvVwb_ItZbg
#define OPTHDROFFSET(ptr) ( \
	(LPVOID)((PBYTE)(ptr) + \
	((PIMAGE_DOS_HEADER)(ptr))->e_lfanew + \
	SIZE_OF_NT_SIGNATURE +  \
	sizeof(IMAGE_FILE_HEADER)))

// ZNVwb_ItZbg
#define SECHDROFFSET(ptr) ( \
	(LPVOID)((PBYTE)(ptr) + \
	((PIMAGE_DOS_HEADER)(ptr))->e_lfanew + \
	SIZE_OF_NT_SIGNATURE +  \
	sizeof(IMAGE_FILE_HEADER) + \
	sizeof(IMAGE_OPTIONAL_HEADER)))

// \̂̋E1oCgݒ
#pragma pack(push, 1)

typedef struct{
	DWORD dwPageRVA;
	DWORD dwBlockSize;
} IMAGE_FIXUP_BLOCK, *PIMAGE_FIXUP_BLOCK;

typedef struct{
	WORD offset:12;
	WORD type:4;
} IMAGE_FIXUP_ENTRY, *PIMAGE_FIXUP_ENTRY;

// DLLC[Wf[^̍\
typedef struct __imageparameters{
	PVOID pImageBase;
	TCHAR svName[MAX_PATH];
	DWORD dwFlags;
	int nLockCount;
	struct __imageparameters *next;
} IMAGE_PARAMETERS, *PIMAGE_PARAMETERS;

#pragma pack(pop)

// DllMaiñ|C^֐
typedef BOOL (WINAPI *DLLMAIN_T)(HMODULE, DWORD, LPVOID);

// DLLf[^x[X̃gbv
PIMAGE_PARAMETERS g_pImageParamHead;
// NeBJZNVϐ
CRITICAL_SECTION g_DLLCrit;


// -------------------------------------------------------------
// 
// -------------------------------------------------------------
void WINAPI InitializeDLLLoad(void)
{
	InitializeCriticalSection(&g_DLLCrit);
	g_pImageParamHead = NULL;
}


// -------------------------------------------------------------
// I
// -------------------------------------------------------------
void WINAPI KillDLLLoad(void)
{
	PIMAGE_PARAMETERS cur = g_pImageParamHead;

	while(cur != NULL){
		PIMAGE_PARAMETERS next = cur->next;
		delete [] cur;
		cur = next;
	}

	DeleteCriticalSection(&g_DLLCrit);
}


// -------------------------------------------------------------
// f[^x[XɐVDLLǉ
// @FDLLnhADLLiʎqj
// ߂lFerror -1, success(find 0, make 1)
// -------------------------------------------------------------
int WINAPI AddDLLReference(PVOID pImageBase, 
					PTCHAR szName,
					DWORD dwFlags)
{
	// szNameȂ΃G[
	if(szName == NULL)
		return -1;

	EnterCriticalSection(&g_DLLCrit);

	PIMAGE_PARAMETERS cur = g_pImageParamHead;
	
	// DLL
	while(cur != NULL){
		if(cur->pImageBase != pImageBase)
			cur = cur->next;
		else{
			cur->nLockCount++;
			LeaveCriticalSection(&g_DLLCrit);
			return 0;
		}
	}
	 
	// VDLL̐
	if((cur = (PIMAGE_PARAMETERS)new IMAGE_PARAMETERS[1]) == NULL){
		LeaveCriticalSection(&g_DLLCrit);
		return -1;
	}
	cur->pImageBase = pImageBase;
	cur->nLockCount = 1;
	cur->dwFlags    = dwFlags;
	cur->next       = g_pImageParamHead;
	lstrcpyn(cur->svName, szName, MAX_PATH);

	g_pImageParamHead = cur;

	LeaveCriticalSection(&g_DLLCrit);
	return 1;
}


// -------------------------------------------------------------
// f[^x[XDLL폜
// @FDLLnhADLLiʎqj
// ߂lFerror -1, success(keep 0, delete 1)
// -------------------------------------------------------------
int WINAPI RemoveDLLReference(PVOID pImageBase, 
					   PTCHAR svName,
					   PDWORD pdwFlags)
{
	EnterCriticalSection(&g_DLLCrit);

	PIMAGE_PARAMETERS prev, cur = g_pImageParamHead;

	// DLL
	while(cur != NULL){
		if(cur->pImageBase == pImageBase)
			break;
		prev = cur;
		cur = cur->next;
	}

	// łȂG[
	if(cur == NULL){
		LeaveCriticalSection(&g_DLLCrit);
		return -1;
	}
	
	cur->nLockCount--;
	*pdwFlags = cur->dwFlags;
	lstrcpyn(svName, cur->svName, MAX_PATH);

	// JE^܂0ȂȂI
	if(cur->nLockCount != 0){
		LeaveCriticalSection(&g_DLLCrit);
		return 0;
	}

	// AXV
	if(prev == NULL)
		g_pImageParamHead = g_pImageParamHead->next;
	else
		prev->next = cur->next;

	delete [] cur;
	LeaveCriticalSection(&g_DLLCrit);
	return 1;
}


// -------------------------------------------------------------
// p[^e[uDLLẴnhԂ
// @FDLLt@C
// ߂lF΂DLL̃nhAȂNULL
// -------------------------------------------------------------
HMODULE WINAPI GetDLLHandle(PTCHAR svName)
{
	if(svName == NULL)
		return NULL;

	EnterCriticalSection(&g_DLLCrit);

	// p[[^e[ũgbv擾
	PIMAGE_PARAMETERS cur = g_pImageParamHead;
	
	// DLL
	while(cur != NULL){
		if(lstrcmpi(cur->svName, svName) != 0)
			cur = cur->next;
		else{
			// nhԂ
			LeaveCriticalSection(&g_DLLCrit);
			return (HMODULE)cur->pImageBase;
		}
	}

	// ȂΏI
	LeaveCriticalSection(&g_DLLCrit);
	return NULL;	
}


// -------------------------------------------------------------
// p[^e[uDLLẴt@CԂ
// @FDLLnhAi[|C^Ai[̈̃TCY
// ߂lF΃t@C̃TCYAȂ0
// -------------------------------------------------------------
DWORD WINAPI GetDLLFileName(HMODULE hModule, 
					 LPTSTR lpFileName, 
					 DWORD dwSize)
{
	if(hModule == NULL || lpFileName == NULL || dwSize == 0)
		return 0;
	
	// ܂͒ʏGetModuleFileNameŒׂ
	DWORD dwRet = GetModuleFileName(hModule, lpFileName, dwSize);
	if(dwRet != 0)
		return dwRet;

	EnterCriticalSection(&g_DLLCrit);

	PIMAGE_PARAMETERS cur = g_pImageParamHead;
	
	// DLL
	while(cur != NULL){
		if(cur->pImageBase != hModule)
			cur=cur->next;
		else{
			// 當ƃTCYԂ
			LeaveCriticalSection(&g_DLLCrit);
			lstrcpyn(lpFileName, cur->svName, dwSize);
			return lstrlen(lpFileName);
		}
	} 

	LeaveCriticalSection(&g_DLLCrit);
	return 0;	
}
					

// -------------------------------------------------------------
// DLLɂGNX|[g֐
// @FDLLnhA֐
// ߂lFȂ֐AhXAsȂNULL
// -------------------------------------------------------------
FARPROC WINAPI GetDLLProcAddress(HMODULE hModule, 
						  LPCSTR lpProcName)
{
	// hModuleNULLȂ΃G[
	if(hModule == NULL)
		return NULL;
	
	// fBNgJEg擾
	PIMAGE_OPTIONAL_HEADER poh = 
		(PIMAGE_OPTIONAL_HEADER)OPTHDROFFSET(hModule);
	int nDirCount = poh->NumberOfRvaAndSizes;
	if(nDirCount < 16)
		return FALSE;

	// GNX|[gfBNge[u擾
	DWORD dwIDEE = IMAGE_DIRECTORY_ENTRY_EXPORT;
	if(poh->DataDirectory[dwIDEE].Size == 0)
		return NULL;
	DWORD dwAddr = poh->DataDirectory[dwIDEE].VirtualAddress;
	PIMAGE_EXPORT_DIRECTORY ped = 
		(PIMAGE_EXPORT_DIRECTORY)RVATOVA(hModule, dwAddr);	
	
	// 擾
	int nOrdinal = (LOWORD(lpProcName)) - ped->Base;
	
	if(HIWORD(lpProcName) != 0){
		int count = ped->NumberOfNames;
		// OƏ擾
		DWORD *pdwNamePtr = (PDWORD)
			RVATOVA(hModule, ped->AddressOfNames);
		WORD *pwOrdinalPtr = (PWORD)
			RVATOVA(hModule, ped->AddressOfNameOrdinals);
		// ֐
		int i;
		for(i=0; i < count; i++, pdwNamePtr++, pwOrdinalPtr++){
			PTCHAR svName = (PTCHAR)RVATOVA(hModule, *pdwNamePtr);
			if(lstrcmp(svName, lpProcName) == 0){
				nOrdinal = *pwOrdinalPtr;
				break;
			}
		}
		// ȂNULLԋp
		if(i == count)
			return NULL;
	}
	
	// ֐Ԃ
	PDWORD pAddrTable = (PDWORD)
		RVATOVA(hModule, ped->AddressOfFunctions);
	return (FARPROC)RVATOVA(hModule, pAddrTable[nOrdinal]);
}


// -------------------------------------------------------------
// DLLDLLMain֐𑖂点֐
// @FDLLnhADLLTCYAAttach or Detach̃tO
// ߂lFerror -1, success(keep 0, delete 1)
// -------------------------------------------------------------
static BOOL WINAPI RunDLLMain(PVOID pImageBase, 
					   DWORD dwImageSize, 
					   BOOL bDetach)
{
	// tǑ
	PIMAGE_FILE_HEADER pfh = (PIMAGE_FILE_HEADER)
		PEFHDROFFSET(pImageBase);
	if((pfh->Characteristics & IMAGE_FILE_DLL) == 0)
		return TRUE;

	// DLLMain֐̃AhX擾
	PIMAGE_OPTIONAL_HEADER poh = (PIMAGE_OPTIONAL_HEADER)
		OPTHDROFFSET(pImageBase);
	DLLMAIN_T pMain = (DLLMAIN_T)
		RVATOVA(pImageBase, poh->AddressOfEntryPoint);

	// f^b`orA^b`
	if(bDetach)
		return pMain((HMODULE)pImageBase, DLL_PROCESS_DETACH, NULL);
	else
		return pMain((HMODULE)pImageBase, DLL_PROCESS_ATTACH, NULL);
}


// -------------------------------------------------------------
// C|[g֐̃AhX֐
// @FDLLt@CC[WADLLt@CC[W̃TCY
// ߂lFTRUEAsFALSE
// -------------------------------------------------------------
BOOL WINAPI PrepareDLLImage(PVOID pMemoryImage, 
					 DWORD dwImageSize)
{
	PIMAGE_OPTIONAL_HEADER poh = 
		(PIMAGE_OPTIONAL_HEADER)OPTHDROFFSET(pMemoryImage);
	int nDirCount = poh->NumberOfRvaAndSizes;
	if(nDirCount < 16)
		return FALSE;

	PIMAGE_SECTION_HEADER psh = 
		(PIMAGE_SECTION_HEADER)SECHDROFFSET(pMemoryImage);

	DWORD dwIDEI = IMAGE_DIRECTORY_ENTRY_IMPORT;

	if(poh->DataDirectory[dwIDEI].Size != 0){
		PIMAGE_IMPORT_DESCRIPTOR pid = 
			(PIMAGE_IMPORT_DESCRIPTOR)RVATOVA(pMemoryImage, 
			poh->DataDirectory[dwIDEI].VirtualAddress);

		for(; pid->OriginalFirstThunk != 0; pid++){
			PTCHAR svDllName = (PTCHAR)
				RVATOVA(pMemoryImage, pid->Name);
			HMODULE hDll = GetModuleHandle(svDllName);
			if(hDll == NULL){
				if((hDll = LoadLibrary(svDllName)) == NULL)
					return FALSE;
			}

			if(pid->TimeDateStamp != 0)
				continue;
			
			pid->ForwarderChain = (DWORD)hDll;
			pid->TimeDateStamp  = IMAGE_PARAMETER_MAGIC;

			typedef struct{
				union{
					DWORD Function;
					DWORD Ordinal;
					DWORD AddressOfData;
				} u1;
			} MY_IMAGE_THUNK_DATA, *PMY_IMAGE_THUNK_DATA;

			PMY_IMAGE_THUNK_DATA ptd_in = (PMY_IMAGE_THUNK_DATA)
				RVATOVA(pMemoryImage, pid->OriginalFirstThunk);
			PMY_IMAGE_THUNK_DATA ptd_out = (PMY_IMAGE_THUNK_DATA)
				RVATOVA(pMemoryImage, pid->FirstThunk);
				
			for(; ptd_in->u1.Function != NULL; ptd_in++, ptd_out++){

				FARPROC func;
				if(ptd_in->u1.Ordinal & 0x80000000){
					func = GetProcAddress(hDll, 
						MAKEINTRESOURCE(ptd_in->u1.Ordinal));
				}else{
					PIMAGE_IMPORT_BY_NAME pibn = 
						(PIMAGE_IMPORT_BY_NAME)RVATOVA(
						pMemoryImage, ptd_in->u1.AddressOfData);
					func = GetProcAddress(hDll, (PTCHAR)pibn->Name);
				}
				
				if(func == NULL)
					return FALSE;
					
				ptd_out->u1.Function = (DWORD)func;
			}
		}
	}

	DWORD dwIDEB = IMAGE_DIRECTORY_ENTRY_BASERELOC;
	DWORD delta = (DWORD)pMemoryImage - (DWORD)poh->ImageBase;

	if((delta == 0) || (poh->DataDirectory[dwIDEB].Size == 0))
		return TRUE;
	
	PIMAGE_FIXUP_BLOCK pfb = (PIMAGE_FIXUP_BLOCK)RVATOVA(
		pMemoryImage, poh->DataDirectory[dwIDEB].VirtualAddress);

	while(pfb->dwPageRVA != 0){
		
		int count = (pfb->dwBlockSize - sizeof(
			IMAGE_FIXUP_BLOCK)) / sizeof(IMAGE_FIXUP_ENTRY);
		PIMAGE_FIXUP_ENTRY pfe = (PIMAGE_FIXUP_ENTRY)
			((PTCHAR)pfb + sizeof(IMAGE_FIXUP_BLOCK));

		for(int i=0; i < count; i++, pfe++){

			PVOID fixaddr = RVATOVA(
				pMemoryImage, pfb->dwPageRVA + pfe->offset);
			
			switch(pfe->type)
			{
			case IMAGE_REL_BASED_ABSOLUTE:
				break;
			case IMAGE_REL_BASED_HIGH:
				*((WORD *)fixaddr) += HIWORD(delta);
				break;
			case IMAGE_REL_BASED_LOW:
				*((WORD *)fixaddr) += LOWORD(delta);
				break;
			case IMAGE_REL_BASED_HIGHLOW:
				*((DWORD *)fixaddr) += delta;
				break;
			case IMAGE_REL_BASED_HIGHADJ:
				*((WORD *)fixaddr) = HIWORD(
					((*((WORD *)fixaddr)) << 16) | 
					(*(WORD *)(pfe+1))+ delta + 0x00008000);
				pfe++;
				break;
			default:
				return FALSE;
			}
		}

		pfb = (PIMAGE_FIXUP_BLOCK)((PTCHAR)pfb + pfb->dwBlockSize);
	}
	return TRUE;
}


// -------------------------------------------------------------
// DLLC[WveNg
// @FDLLt@CC[W
// ߂lFTRUEAsFALSE
// -------------------------------------------------------------
BOOL WINAPI ProtectDLLImage(PVOID pMemoryImage)
{
	// ZNV擾
	PIMAGE_FILE_HEADER pfh = 
		(PIMAGE_FILE_HEADER)PEFHDROFFSET(pMemoryImage);
	int nSectionCount = pfh->NumberOfSections;

	// ZNVwb_擾
	PIMAGE_SECTION_HEADER psh = 
		(PIMAGE_SECTION_HEADER)SECHDROFFSET(pMemoryImage);

	for(int i=0; i < nSectionCount; i++, psh++){

		// ZNVAhXƃTCY̎擾
		PVOID secMemAddr = (PTCHAR)
			RVATOVA(pMemoryImage, psh->VirtualAddress);
		
		DWORD chr = psh->Characteristics;
		// veNgtO̐ݒ
		BOOL bWrite  = (chr & IMAGE_SCN_MEM_WRITE)   ? TRUE : FALSE;
		BOOL bRead   = (chr & IMAGE_SCN_MEM_READ)    ? TRUE : FALSE;
		BOOL bExec   = (chr & IMAGE_SCN_MEM_EXECUTE) ? TRUE : FALSE;
		BOOL bShared = (chr & IMAGE_SCN_MEM_SHARED)  ? TRUE : FALSE;
		
		DWORD newProtect = 0;
		// tO
		if(bWrite && bRead && bExec && bShared)
			newProtect = PAGE_EXECUTE_READWRITE;
		else if(bWrite && bRead && bExec)
			newProtect = PAGE_EXECUTE_WRITECOPY;
		else if(bRead && bExec)
			newProtect = PAGE_EXECUTE_READ;
		else if(bExec)
			newProtect = PAGE_EXECUTE;
		else if(bWrite && bRead && bShared)
			newProtect = PAGE_READWRITE; 
		else if(bWrite && bRead)
			newProtect = PAGE_WRITECOPY;
		else if(bRead)
			newProtect = PAGE_READONLY;

		if(chr & IMAGE_SCN_MEM_NOT_CACHED)
			newProtect |= PAGE_NOCACHE;

		if(newProtect == 0)
			return FALSE;

		DWORD oldProtect;
		// veNgs
		//VirtualProtect(secMemAddr, 
		//	psh->SizeOfRawData, newProtect, &oldProtect);
	}
	return TRUE;
}


// -------------------------------------------------------------
// DLLC[WRs[֐
// @FDLLt@CC[WARs[|C^
// ߂lFTRUEAsFALSE
// -------------------------------------------------------------
BOOL WINAPI MapDLLFromImage(PVOID pDLLFileImage, 
					 PVOID pMemoryImage)
{
	// PEwb_ƃZNVwb_Rs[
	PIMAGE_OPTIONAL_HEADER poh = 
		(PIMAGE_OPTIONAL_HEADER)OPTHDROFFSET(pDLLFileImage);
	memcpy(pMemoryImage, pDLLFileImage, poh->SizeOfHeaders);
	VirtualAlloc((LPVOID)pMemoryImage, poh->SizeOfHeaders/* + SIZE_OF_PARAMETER_BLOCK*/, MEM_COMMIT, PAGE_EXECUTE_READWRITE);

	// ZNV擾
	PIMAGE_FILE_HEADER pfh = (PIMAGE_FILE_HEADER)
		PEFHDROFFSET(pDLLFileImage);
	int nSectionCount = pfh->NumberOfSections;

	// ZNVwb_|C^擾
	PIMAGE_SECTION_HEADER psh = 
		(PIMAGE_SECTION_HEADER)SECHDROFFSET(pDLLFileImage);

	// ׂẴZNṼRs[
	for(int i=0; i < nSectionCount; i++, psh++){
		PTCHAR secMemAddr  = (PTCHAR)
			((PTCHAR)pMemoryImage + psh->VirtualAddress);
		PTCHAR secFileAddr = (PTCHAR)
			((PTCHAR)pDLLFileImage + psh->PointerToRawData);
		int secLen = psh->SizeOfRawData;
		VirtualAlloc((LPVOID)secMemAddr, secLen/* + SIZE_OF_PARAMETER_BLOCK*/, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
		memcpy(secMemAddr, secFileAddr, secLen);
	}
	return TRUE;
}


// -------------------------------------------------------------
// DLLC[WDLL[h֐
// @FDLLt@CC[WA}bsOiʎqjAtO
// ߂lFDLLnhAsNULL
// -------------------------------------------------------------
HMODULE WINAPI LoadDLLFromImage(LPVOID pDLLFileImage, 
						 PTCHAR szMappingName,
						 DWORD dwFlags)
{
	// }bsOȂ΃G[
	if(szMappingName == NULL)
		return NULL;

	// }bsÕTCY𔻒
	if(lstrlen(szMappingName) >= MAX_PATH)
		return NULL;
	
	// PEf[^̔
	PIMAGE_DOS_HEADER doshead = (PIMAGE_DOS_HEADER)pDLLFileImage;
	if(doshead->e_magic != IMAGE_DOS_SIGNATURE)
		return NULL;
	if(*(DWORD *)NTSIGNATURE(pDLLFileImage) != IMAGE_NT_SIGNATURE)
		return NULL;
	PIMAGE_OPTIONAL_HEADER poh = 
		(PIMAGE_OPTIONAL_HEADER)OPTHDROFFSET(pDLLFileImage);
	if(poh->Magic != 0x010B)
		return NULL;

	// ZNV擾
	PIMAGE_FILE_HEADER pfh = 
		(PIMAGE_FILE_HEADER)PEFHDROFFSET(pDLLFileImage);
	int nSectionCount = pfh->NumberOfSections;

	DWORD pPreferredImageBase = poh->ImageBase;
	DWORD dwImageSize = poh->SizeOfImage;

	PVOID pImageBase;
	HANDLE hmapping = NULL;
	// DLLnhȂΐV
	if((pImageBase = GetDLLHandle(szMappingName)) == NULL){
		BOOL bCreated = FALSE;
		// łɃ}bsOĂ邩ǂ
		hmapping = OpenFileMapping(
			FILE_MAP_WRITE, TRUE, szMappingName);
		// ĂȂȂ琶
		if(hmapping == NULL){
			hmapping = CreateFileMapping(
				INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, 
				dwImageSize + SIZE_OF_PARAMETER_BLOCK, szMappingName);
			if(hmapping == NULL)
				return NULL;
			bCreated = TRUE;
		}

		// }bsOĂf[^̐擪pImageBase
		pImageBase = MapViewOfFileEx(
			hmapping, FILE_MAP_WRITE, 0, 0, 0, (LPVOID)pPreferredImageBase);
		// Ȃ VirtualProtect ŝŁA VirtualAlloc gĂ݂炤܂p^[iӖȂj
		//VirtualAlloc((LPVOID)pImageBase, dwImageSize/* + SIZE_OF_PARAMETER_BLOCK*/, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
		if(pImageBase == NULL){
			pImageBase = MapViewOfFileEx(
				hmapping, FILE_MAP_WRITE, 0, 0, 0, NULL);
		}
		CloseHandle(hmapping);
		if(pImageBase == NULL)
			return NULL;

		// VꂽAx[XAhXςĂ
		if(bCreated || (pImageBase != (LPVOID)pPreferredImageBase)){
			// DLLC[W}bsO
			if( ! MapDLLFromImage(pDLLFileImage, pImageBase)){
				UnmapViewOfFile(pImageBase);
				return NULL;
			}
		}
		
		// LOAD_LIBRARY_AS_DATAFILEĂȂȂ
		if( ! (dwFlags & LOAD_LIBRARY_AS_DATAFILE)){
			// 
			if( ! PrepareDLLImage(pImageBase, dwImageSize)){
				UnmapViewOfFile(pImageBase);
				return NULL;
			}
			
			// tODONT_RESOLVE_DLL_REFERENCESĂȂ
			if( ! (dwFlags & DONT_RESOLVE_DLL_REFERENCES)){
				// DLLMainsiA^b`j
				if( ! RunDLLMain(pImageBase, dwImageSize, DLL_ATTACH)){
					UnmapViewOfFile(pImageBase);
					return NULL;
				}
			}

			// veNgs
			if( ! ProtectDLLImage(pImageBase)){
				UnmapViewOfFile(pImageBase);
				return NULL;
			}
		}
	}
	
	// DLLf[^x[X֒ǉ
	if(AddDLLReference(pImageBase, szMappingName, dwFlags) == -1){
		if(hmapping != NULL)
			UnmapViewOfFile(pImageBase);
		return NULL;
	}	

	return (HMODULE)pImageBase;	
}


// -------------------------------------------------------------
// DLL[h֐
// @FDLLt@CA\iNULLŒjAtO
// ߂lFDLLnhAsNULL
// -------------------------------------------------------------
HMODULE WINAPI LoadDLLEx(LPCTSTR lpLibFileName,
				  HANDLE hReserved,
				  DWORD dwFlags)
{
	// փt@C@w
	// iLOAD_WITH_ALTERED_SEARCH_PATHj̓T|[gȂ
	if(dwFlags & LOAD_WITH_ALTERED_SEARCH_PATH)
		return NULL;

	// DLLpX擾
	TCHAR szPath[MAX_PATH + 1], *szFilePart;
	int nLen = SearchPath(NULL, lpLibFileName, 
		".dll", MAX_PATH, szPath, &szFilePart);
	if(nLen == 0)
		return NULL;

	// t@C}bsO
	HANDLE hFile = CreateFile(
		szPath, GENERIC_READ, FILE_SHARE_READ, 
		NULL, OPEN_EXISTING, 0, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return NULL;
	HANDLE hMapping = CreateFileMapping(
		hFile, NULL, PAGE_READONLY, 0, 0, NULL);
	CloseHandle(hFile);
	LPVOID pBaseAddr = MapViewOfFile(
		hMapping, FILE_MAP_READ, 0, 0, 0);
	if(pBaseAddr == NULL){
		CloseHandle(hMapping);
		return NULL;
	}

	// DLLC[W̓ǂݍ
	HMODULE hRet = LoadDLLFromImage(pBaseAddr, 
		szFilePart, dwFlags & ~LOAD_WITH_ALTERED_SEARCH_PATH);

	// t@C}bsO
	UnmapViewOfFile(pBaseAddr);
	CloseHandle(hMapping);
	return hRet;
}


// -------------------------------------------------------------
// DLL[h֐iLoadDLLExւ̋nj
// @FDLLt@C
// ߂lFDLLnhAsNULL
// -------------------------------------------------------------
HMODULE WINAPI LoadDLL(LPCTSTR lpLibFileName)
{
	return LoadDLLEx(lpLibFileName, NULL, 0);
}


// -------------------------------------------------------------
// DLLJ֐
// @FDLLnh
// ߂lFTRUEAsFALSE
// -------------------------------------------------------------
BOOL FreeDLL(HMODULE hLibModule)
{
	// hLibModuleNULLȂO
	if(hLibModule == NULL)
		return FALSE;
	
	// PEf[^̎
	PIMAGE_DOS_HEADER doshead = (PIMAGE_DOS_HEADER)hLibModule;
	if(doshead->e_magic != IMAGE_DOS_SIGNATURE)
		return FALSE;
	if(*(PDWORD)NTSIGNATURE(hLibModule) != IMAGE_NT_SIGNATURE)
		return FALSE;
	PIMAGE_OPTIONAL_HEADER poh = 
		(PIMAGE_OPTIONAL_HEADER)OPTHDROFFSET(hLibModule);
	if(poh->Magic != 0x010B)
		return FALSE;

	DWORD dwFlags;
	TCHAR szName[MAX_PATH];
	// DLLf[^x[X͂
	int dllaction = RemoveDLLReference(hLibModule, szName, &dwFlags);
	if(dllaction == -1)
		return FALSE;

	// DLL̃f^b`
	if( ! (dwFlags & (LOAD_LIBRARY_AS_DATAFILE | 
		DONT_RESOLVE_DLL_REFERENCES)))
	{	// JE^0idllaction=1jȂDLLf^b`ďI
		if(dllaction){
			RunDLLMain(hLibModule, poh->SizeOfImage, DLL_DETACH);
			return UnmapViewOfFile(hLibModule);
		}
	}
	return TRUE;
}


typedef int (*PADDFUNC)(int, int);
typedef int (*PSUBFUNC)(int, int);

/*
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	InitializeDLLLoad();
	HMODULE hHandle = LoadDLL(_T("test_dll"));
	PADDFUNC pAdd = (PADDFUNC)GetDLLProcAddress(hHandle, _T("add_num"));
	int a = (*pAdd)(3, 5);  // 3 + 5 = 8
	PSUBFUNC pSub = (PSUBFUNC)GetDLLProcAddress(
		GetDLLHandle(_T("test_dll.dll")), _T("sub_num"));
	int b = (*pSub)(8, 5);  // 8 - 5 = 3
	TCHAR szFileName[MAX_PATH];
	GetDLLFileName(hHandle, szFileName, sizeof(szFileName));
	TCHAR szBuffer[1024];
	wsprintf(szBuffer, _T(
		"FileName = %s\r\na = %d, b = %d\r\n"), szFileName, a, b);
	MessageBox(GetActiveWindow(), szBuffer, _T("Message"), MB_OK);
	FreeDLL(hHandle);
	KillDLLLoad();
	return 0;
}
*/